package thesis.algorithms.evolutionary.bivariate;

public class Edge {
	private int firstVertex;
	private int secondVertex;

	private int maxBits;

	public Edge(int firstVertex, int secondVertex, int maxBits) {

		if (firstVertex < secondVertex) {
			this.firstVertex = firstVertex;
			this.secondVertex = secondVertex;
		} else {
			this.firstVertex = secondVertex;
			this.secondVertex = firstVertex;
		}
		this.maxBits = maxBits;
	}

	@Override
	public boolean equals(Object obj) {
		if (obj == null)
			return false;

		if (!(obj instanceof Edge))
			return false;

		Edge e = (Edge) obj;

		if (e.getFirstVertex() != this.firstVertex)
			return false;

		if (e.getSecondVertex() != this.secondVertex)
			return false;

		return true;
	}

	@Override
	public int hashCode() {

		return firstVertex * (maxBits + 1) + secondVertex;
	}

	public int getFirstVertex() {
		return firstVertex;
	}

	public int getSecondVertex() {
		return secondVertex;
	}
}
