package thesis.algorithms.evolutionary.genetic.operators;

import java.util.Random;

import thesis.util.Chromosome;

public class NormalMutation implements IMutation {
	private double mutation;
	private Random randomGenerator;

	public NormalMutation(double mutation) {
		this.mutation = mutation;
		randomGenerator = new Random();
	}

	@Override
	public void mutation(Chromosome individual) {

		boolean[] chromosombeBinaryRepresentation = individual
				.getBinaryRepresentation();
		for (int j = 0; j < chromosombeBinaryRepresentation.length; ++j) {
			if (randomGenerator.nextFloat() < mutation) {
				chromosombeBinaryRepresentation[j] = !chromosombeBinaryRepresentation[j];
			}
		}

	}

}
