package thesis.algorithms.evolutionary.genetic.operators;

import java.util.Arrays;
import java.util.Random;

import thesis.util.Chromosome;

public class ThreeTournamentSelection implements ISelection {

	@Override
	public Chromosome[] selection(Chromosome[] population) {
		Chromosome[] choosen = new Chromosome[3];
		Random rand = new Random();
		int first = rand.nextInt(population.length);
		
		int second = (first + population.length / 3) % population.length;
		int third = (second + population.length / 3) % population.length;

//		int second = rand.nextInt(population.length);
//		int third = rand.nextInt(population.length);

		choosen[0] = population[first];
		choosen[1] = population[second];
		choosen[2] = population[third];
		
		Arrays.sort(choosen);
		return choosen;
	}

}
