package thesis.algorithms.evolutionary.genetic.operators;

import java.util.Random;

import thesis.util.Chromosome;

public class UniformCrossover implements ICrossing {

	private double crossing;
	private Random randomGenerator;

	public UniformCrossover(double crossing) {
		this.crossing = crossing;
		randomGenerator = new Random();
	}

	@Override
	public void crossing(Chromosome[] parents) {
		
		if (parents == null) {
			throw new NullPointerException();
		}
		if (parents.length != 3) {
			throw new IllegalArgumentException();
		}
		if (randomGenerator.nextFloat() < crossing) {

			int representationLength = parents[0].getLength();
			for (int i = 0; i < representationLength; ++i) {

				if (randomGenerator.nextBoolean()) {

					boolean newValue = parents[0].getBit(i);
					parents[2].setBit(i, newValue);
				} else {

					boolean newValue = parents[1].getBit(i);
					parents[2].setBit(i, newValue);
				}
			}
		}
	}

}
