package thesis.algorithms.evolutionary.univariate.probability_vector;

import java.util.Arrays;

import thesis.util.Chromosome;

public class UMDAProbabilityVector implements IProbabilityVector {

	private double[] probabilityVector;
	private int[] totalBitsNumber;
	private int[] totalOnesNumber;

	public UMDAProbabilityVector(int vectorSize) {
		this.probabilityVector = new double[vectorSize];
		Arrays.fill(probabilityVector, 0.5);
		totalBitsNumber = new int[vectorSize];
		totalOnesNumber = new int[vectorSize];
	}


	private void updateProbabilityVector(Chromosome bestIndividual) {

		for (int i = 0; i < bestIndividual.getBinaryRepresentation().length; ++i) {
			++totalBitsNumber[i];
			if (bestIndividual.getBinaryRepresentation()[i])
				++totalOnesNumber[i];

			probabilityVector[i] = (double) totalOnesNumber[i]
					/ (double) totalBitsNumber[i];
		}
		
	}

	@Override
	public void updateProbabilityVector(Chromosome[] bestIndividuals) {
		
		Arrays.fill(probabilityVector, 0);
		
		for(int i=0;i<bestIndividuals.length;++i){
			updateProbabilityVector(bestIndividuals[i]);
		}		
	}

	@Override
	public double[] getProbabilityVector() {
		return probabilityVector;
	}

}
