package thesis.executors;

import thesis.algorithms.evolutionary.univariate.CompactGA;
import thesis.functions.RastriginFunction;
import thesis.interfaces.IDecoder;
import thesis.interfaces.IFunction;
import thesis.util.ChromosomeDecoder;

public class CGAExecutor {

	private static final int xMin = -10;
	private static final int xMax = 10;
	private static final int dimensionNumber = 10;
	private static final double precision = 0.01;
	private static final int populationSize = 50;
	private static final int iterations = 5000;

	public static void main(String[] args) {

		IDecoder decoder = new ChromosomeDecoder(xMin, xMax, dimensionNumber,
				precision);
		IFunction function = new RastriginFunction();

		CompactGA algorithm = new CompactGA(populationSize, 1 / populationSize,
				decoder, function);

		algorithm.initializePopulation();
		for (int i = 0; i < iterations; i++) {
			algorithm.iterate();
		}
	}

}
