package thesis.executors;

import thesis.algorithms.evolutionary.univariate.PBIL;
import thesis.functions.RastriginFunction;
import thesis.interfaces.IDecoder;
import thesis.interfaces.IFunction;
import thesis.util.ChromosomeDecoder;



public class PBILExecutor {

	private static final double mutationStep = 0.01;
	private static final double learningRate = 0.5;
	private static final int xMin = -10;
	private static final int xMax = 10;
	private static final int dimensionNumber = 10;
	private static final double precision = 0.01;
	private static final int populationSize = 50;
	private static final int iterations = 100;

	public static void main(String[] args) {
		
		IDecoder decoder = new ChromosomeDecoder(xMin, xMax, dimensionNumber,
				precision);
		IFunction function = new RastriginFunction();

		PBIL pbil = new PBIL(populationSize, mutationStep, learningRate,
				decoder, function);
		
		pbil.initializePopulation();
		for (int i = 0; i < iterations; i++) {
			pbil.iterate();
		}

	}
}
