package thesis.functions;

import thesis.interfaces.IFunction;

public class RosenbrockFunction implements IFunction {

	@Override
	public double calculate(double[] values) {
		int solution = 0;

		for (int i = 0; i < values.length - 1; i++) {
			solution += 1. - values[i];
			solution += 100 * (values[i + 1] - values[i] * values[i])
					* (values[i + 1] - values[i] * values[i]);
		}
		return solution;
	}

}
